let fs = require('fs'),
  path = require("path")

// mkdirs

let mkdirs = (dirpath, mode) => {
  if (!fs.existsSync(dirpath)) {
    let pathtmp
    dirpath.split(path.sep).forEach(function(dirname) {
      if (pathtmp) {
        pathtmp = path.join(pathtmp, dirname)
      } else {
        pathtmp = dirname
      }
      if (!fs.existsSync(pathtmp)) {
        if (!fs.mkdirSync(pathtmp, mode)) {
          return false
        }
      }
    })
  }
  return true
}

// babel

let createIoingDemo = (callback) => {
  let options = process.argv.slice(2)
  let id = options[2]
  let type = options[1].replace(/^-+/, '')
  let time = Date.now()
  let uri

  switch (type) {
    case 'module':
      id = id || 'new-module-' + time
      uri = "modules/" + id
      if (mkdirs(uri, 0777)) {
        let fsopt = {
          encoding: 'utf8',
          mode: 777,
          flag: 'w'
        }

        fs.writeFile(uri + "/config.js", `
export default {
    resources : {
        script : {
        },
        source : {
            index : "index.html"
        },
        style : {
          main : "main.css"
        },
        data : {
          lang : ["你好！", "Hello!", "こんにちは!", "안녕 하세요!", "bonjour!", "Hallo!", "Ciao!", "Hola!", "Здравствуйте!"]
        }
    },
    config : {
      leve : 1,
        absolute : true,
        background : "#fff",
        style : ["main"],
        script : [],
        source : ["index"],
        data : ["lang"],
        cache : 360,
        sandbox : true,
        shadowbox : false,
        animation : "slide"
    },
    helper : {
    },
    controller : {
    }
}
          `, fsopt, function(err) {
          if (err) {
            return console.log(err)
          }
        })

        fs.writeFile(uri + "/main.css", `
h1 {
  position: absolute;
    width: 100%;
    top: 45%;
  font-size: 36dp;
  color: #333;
  font-weight: 300;
  text-align: center;
  opacity: 0;
  transition: opacity .3s;
}
h1.active {
  opacity: 1;
}
          `, fsopt, function(err) {
          if (err) {
            return console.log(err)
          }
        })

        fs.writeFile(uri + "/index.html", `
<script sync>
  scope.cur = 0
</script>
<scroll fullscreen>
  <scrolling>
    <loop lang as val i>
      <h1 class="{{cur == i ? 'active' : ''}}">{val}</h1>
    </loop>
  </scrolling>
</scroll>
<script>
    setInterval(function () {
      if ( scope.cur == scope.lang.length - 1 ) {
        scope.cur = 0
      } else {
        scope.cur++
      }
    }, 2500)
</script>
          `, fsopt, function(err) {
          if (err) {
            return console.log(err)
          }
          browser.href = '#' + id
          callback && callback()
          console.log("模块[" + id + "]创建成功！")
        })
      } else {
        console.log("模块[" + id + "]创建失败！")
      }

      break

    case 'components':
      id = id || 'new-components' + time
      uri = "components/" + id
      if (mkdirs(uri, 0777)) {
        fs.writeFile(uri + "/index.html", `
<style>
  h1 {
    font-size: 14dp;
  }
</style>
<h1>components content</h1>
          `, fsopt, function(err) {
          if (err) {
            return console.log(err)
          }
          console.log("组件[" + id + "]创建成功！")
        })
      } else {
        console.log("组件[" + id + "]创建失败！")
      }

      break

    default:
      console.log("命令错误！")
      break
  }
}

module.exports = createIoingDemo
